Index: dll/win32/shdocvw/shdocvw.h
===================================================================
--- dll/win32/shdocvw/shdocvw.h	(Revision 31635)
+++ dll/win32/shdocvw/shdocvw.h	(Arbeitskopie)
@@ -2,6 +2,7 @@
  * Header includes for shdocvw.dll
  *
  * Copyright 2001 John R. Sheets (for CodeWeavers)
+ * Copyright 2005-2006 Jacek Caban for CodeWeavers
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
@@ -15,7 +16,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #ifndef __WINE_SHDOCVW_H
@@ -36,6 +37,7 @@
 #include "shlobj.h"
 #include "exdisp.h"
 #include "mshtmhst.h"
+#include "hlink.h"
 
 /**********************************************************************
  * IClassFactory declaration for SHDOCVW.DLL
@@ -44,6 +46,7 @@
 {
     /* IUnknown fields */
     const IClassFactoryVtbl *lpVtbl;
+    HRESULT (*cf)(LPUNKNOWN, REFIID, LPVOID *);
     LONG ref;
 } IClassFactoryImpl;
 
@@ -62,6 +65,48 @@
 typedef struct ConnectionPoint ConnectionPoint;
 
 typedef struct {
+    const IConnectionPointContainerVtbl *lpConnectionPointContainerVtbl;
+
+    ConnectionPoint *wbe2;
+    ConnectionPoint *wbe;
+    ConnectionPoint *pns;
+
+    IUnknown *impl;
+} ConnectionPointContainer;
+
+typedef struct {
+    const IOleClientSiteVtbl      *lpOleClientSiteVtbl;
+    const IOleInPlaceSiteVtbl     *lpOleInPlaceSiteVtbl;
+    const IDocHostUIHandler2Vtbl  *lpDocHostUIHandlerVtbl;
+    const IOleDocumentSiteVtbl    *lpOleDocumentSiteVtbl;
+    const IOleCommandTargetVtbl   *lpOleCommandTargetVtbl;
+    const IDispatchVtbl           *lpDispatchVtbl;
+    const IServiceProviderVtbl    *lpServiceProviderVtbl;
+
+    /* Interfaces of InPlaceFrame object */
+    const IOleInPlaceFrameVtbl          *lpOleInPlaceFrameVtbl;
+
+    IDispatch *disp;
+
+    IDispatch *client_disp;
+    IDocHostUIHandler *hostui;
+    IOleInPlaceFrame *frame;
+
+    IUnknown *document;
+    IOleDocumentView *view;
+
+    HWND hwnd;
+    HWND frame_hwnd;
+
+    LPOLESTR url;
+
+    VARIANT_BOOL silent;
+    VARIANT_BOOL offline;
+
+    ConnectionPointContainer cps;
+} DocHost;
+
+typedef struct {
     /* Interfaces available via WebBrowser object */
 
     const IWebBrowser2Vtbl              *lpWebBrowser2Vtbl;
@@ -69,60 +114,61 @@
     const IOleInPlaceObjectVtbl         *lpOleInPlaceObjectVtbl;
     const IOleControlVtbl               *lpOleControlVtbl;
     const IPersistStorageVtbl           *lpPersistStorageVtbl;
+    const IPersistMemoryVtbl            *lpPersistMemoryVtbl;
     const IPersistStreamInitVtbl        *lpPersistStreamInitVtbl;
     const IProvideClassInfo2Vtbl        *lpProvideClassInfoVtbl;
     const IQuickActivateVtbl            *lpQuickActivateVtbl;
-    const IConnectionPointContainerVtbl *lpConnectionPointContainerVtbl;
     const IViewObject2Vtbl              *lpViewObjectVtbl;
     const IOleInPlaceActiveObjectVtbl   *lpOleInPlaceActiveObjectVtbl;
+    const IOleCommandTargetVtbl         *lpOleCommandTargetVtbl;
+    const IHlinkFrameVtbl               *lpHlinkFrameVtbl;
 
-    /* Interfaces available for embeded document */
-
-    const IOleClientSiteVtbl            *lpOleClientSiteVtbl;
-    const IOleInPlaceSiteVtbl           *lpOleInPlaceSiteVtbl;
-    const IDocHostUIHandler2Vtbl        *lpDocHostUIHandlerVtbl;
-    const IOleDocumentSiteVtbl          *lpOleDocumentSiteVtbl;
-
-    /* Interfaces of InPlaceFrame object */
-
-    const IOleInPlaceFrameVtbl          *lpOleInPlaceFrameVtbl;
-
     LONG ref;
 
-    IUnknown *document;
+    INT version;
 
     IOleClientSite *client;
     IOleContainer *container;
-    IOleDocumentView *view;
+    IOleInPlaceSite *inplace;
 
-    LPOLESTR url;
-
     /* window context */
 
-    HWND iphwnd;
     HWND frame_hwnd;
-    IOleInPlaceFrame *frame;
     IOleInPlaceUIWindow *uiwindow;
     RECT pos_rect;
     RECT clip_rect;
     OLEINPLACEFRAMEINFO frameinfo;
+    SIZEL extent;
 
-    HWND doc_view_hwnd;
     HWND shell_embedding_hwnd;
 
-    /* Connection points */
+    VARIANT_BOOL visible;
+    VARIANT_BOOL menu_bar;
+    VARIANT_BOOL address_bar;
+    VARIANT_BOOL status_bar;
+    VARIANT_BOOL tool_bar;
+    VARIANT_BOOL full_screen;
 
-    ConnectionPoint *cp_wbe2;
-    ConnectionPoint *cp_wbe;
-    ConnectionPoint *cp_pns;
+    DocHost doc_host;
 } WebBrowser;
 
+typedef struct {
+    const IWebBrowser2Vtbl *lpWebBrowser2Vtbl;
+
+    LONG ref;
+
+    HWND frame_hwnd;
+
+    DocHost doc_host;
+} InternetExplorer;
+
 #define WEBBROWSER(x)   ((IWebBrowser*)                 &(x)->lpWebBrowser2Vtbl)
 #define WEBBROWSER2(x)  ((IWebBrowser2*)                &(x)->lpWebBrowser2Vtbl)
 #define OLEOBJ(x)       ((IOleObject*)                  &(x)->lpOleObjectVtbl)
 #define INPLACEOBJ(x)   ((IOleInPlaceObject*)           &(x)->lpOleInPlaceObjectVtbl)
 #define CONTROL(x)      ((IOleControl*)                 &(x)->lpOleControlVtbl)
 #define PERSTORAGE(x)   ((IPersistStorage*)             &(x)->lpPersistStorageVtbl)
+#define PERMEMORY(x)    ((IPersistMemory*)              &(x)->lpPersistMemoryVtbl)
 #define PERSTRINIT(x)   ((IPersistStreamInit*)          &(x)->lpPersistStreamInitVtbl)
 #define CLASSINFO(x)    ((IProvideClassInfo2*)          &(x)->lpProvideClassInfoVtbl)
 #define QUICKACT(x)     ((IQuickActivate*)              &(x)->lpQuickActivateVtbl)
@@ -130,12 +176,16 @@
 #define VIEWOBJ(x)      ((IViewObject*)                 &(x)->lpViewObjectVtbl);
 #define VIEWOBJ2(x)     ((IViewObject2*)                &(x)->lpViewObjectVtbl);
 #define ACTIVEOBJ(x)    ((IOleInPlaceActiveObject*)     &(x)->lpOleInPlaceActiveObjectVtbl)
+#define OLECMD(x)       ((IOleCommandTarget*)           &(x)->lpOleCommandTargetVtbl)
+#define HLINKFRAME(x)   ((IHlinkFrame*)                 &(x)->lpHlinkFrameVtbl)
 
 #define CLIENTSITE(x)   ((IOleClientSite*)              &(x)->lpOleClientSiteVtbl)
 #define INPLACESITE(x)  ((IOleInPlaceSite*)             &(x)->lpOleInPlaceSiteVtbl)
 #define DOCHOSTUI(x)    ((IDocHostUIHandler*)           &(x)->lpDocHostUIHandlerVtbl)
 #define DOCHOSTUI2(x)   ((IDocHostUIHandler2*)          &(x)->lpDocHostUIHandlerVtbl)
 #define DOCSITE(x)      ((IOleDocumentSite*)            &(x)->lpOleDocumentSiteVtbl)
+#define CLDISP(x)       ((IDispatch*)                   &(x)->lpDispatchVtbl)
+#define SERVPROV(x)     ((IServiceProvider*)            &(x)->lpServiceProviderVtbl)
 
 #define INPLACEFRAME(x) ((IOleInPlaceFrame*)            &(x)->lpOleInPlaceFrameVtbl)
 
@@ -143,23 +193,37 @@
 void WebBrowser_ViewObject_Init(WebBrowser*);
 void WebBrowser_Persist_Init(WebBrowser*);
 void WebBrowser_ClassInfo_Init(WebBrowser*);
+void WebBrowser_HlinkFrame_Init(WebBrowser*);
 void WebBrowser_Misc_Init(WebBrowser*);
 void WebBrowser_Events_Init(WebBrowser*);
 
-void WebBrowser_ClientSite_Init(WebBrowser*);
-void WebBrowser_DocHost_Init(WebBrowser*);
+void WebBrowser_OleObject_Destroy(WebBrowser*);
 
-void WebBrowser_Frame_Init(WebBrowser*);
+void DocHost_Init(DocHost*,IDispatch*);
+void DocHost_ClientSite_Init(DocHost*);
+void DocHost_Frame_Init(DocHost*);
 
-void WebBrowser_OleObject_Destroy(WebBrowser*);
 void WebBrowser_Events_Destroy(WebBrowser*);
-void WebBrowser_ClientSite_Destroy(WebBrowser*);
+void DocHost_Release(DocHost*);
+void DocHost_ClientSite_Release(DocHost*);
 
-HRESULT WebBrowser_Create(IUnknown*,REFIID,void**);
+void ConnectionPointContainer_Init(ConnectionPointContainer*,IUnknown*);
+void ConnectionPointContainer_Destroy(ConnectionPointContainer*);
 
-void create_doc_view_hwnd(WebBrowser *This);
+HRESULT WebBrowserV1_Create(IUnknown*,REFIID,void**);
+HRESULT WebBrowserV2_Create(IUnknown*,REFIID,void**);
+
+void create_doc_view_hwnd(DocHost*);
+void deactivate_document(DocHost*);
 void call_sink(ConnectionPoint*,DISPID,DISPPARAMS*);
+HRESULT navigate_url(DocHost*,LPCWSTR,const VARIANT*,const VARIANT*,VARIANT*,VARIANT*);
+HRESULT go_home(DocHost*);
 
+HRESULT InternetExplorer_Create(IUnknown*,REFIID,void**);
+void InternetExplorer_WebBrowser_Init(InternetExplorer*);
+
+HRESULT CUrlHistory_Create(IUnknown*,REFIID,void**);
+
 #define WB_WM_NAVIGATE2 (WM_USER+100)
 
 #define DEFINE_THIS(cls,ifc,iface) ((cls*)((BYTE*)(iface)-offsetof(cls,lp ## ifc ## Vtbl)))
@@ -172,5 +236,11 @@
 static inline void SHDOCVW_UnlockModule(void) { InterlockedDecrement( &SHDOCVW_refCount ); }
 
 extern HINSTANCE shdocvw_hinstance;
+extern void register_iewindow_class(void);
+extern void unregister_iewindow_class(void);
 
+HRESULT register_class_object(BOOL);
+HRESULT get_typeinfo(ITypeInfo**);
+DWORD register_iexplore(BOOL);
+
 #endif /* __WINE_SHDOCVW_H */
Index: dll/win32/shdocvw/shdocvw.spec
===================================================================
--- dll/win32/shdocvw/shdocvw.spec	(Revision 31635)
+++ dll/win32/shdocvw/shdocvw.spec	(Arbeitskopie)
@@ -1,8 +1,8 @@
 # ordinal exports
-101 stub -noname IEWinMain
+101 stdcall -noname IEWinMain(str long)
 102 stub -noname CreateShortcutInDirA
 103 stub -noname CreateShortcutInDirW
-104 stub -noname WhichPlatformFORWARD
+104 stdcall -noname WhichPlatformFORWARD()
 105 stub -noname CreateShortcutInDirEx
 106 stub HlinkFindFrame
 107 stub SetShellOfflineState
@@ -15,9 +15,10 @@
 118 stdcall -noname ShellDDEInit(long)
 119 stub -noname SHCreateDesktop
 120 stub -noname SHDesktopMessageLoop
-121 stub -noname StopWatchModeFORWARD
-122 stub -noname StopWatchFlushFORWARD
-123 stub -noname StopWatchFORWARD
+121 stdcall -noname StopWatchModeFORWARD()
+122 stdcall -noname StopWatchFlushFORWARD()
+123 stdcall -noname StopWatchAFORWARD(long str long long long)
+124 stdcall -noname StopWatchWFORWARD(long wstr long long long)
 125 stdcall -noname RunInstallUninstallStubs()
 130 stub -noname RunInstallUninstallStubs2
 131 stub -noname SHCreateSplashScreen
Index: dll/win32/shdocvw/persist.c
===================================================================
--- dll/win32/shdocvw/persist.c	(Revision 31635)
+++ dll/win32/shdocvw/persist.c	(Arbeitskopie)
@@ -16,7 +16,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include "wine/debug.h"
@@ -67,7 +67,7 @@
 {
     WebBrowser *This = PERSTORAGE_THIS(iface);
     FIXME("(%p)->(%p)\n", This, pStg);
-    return E_NOTIMPL;
+    return S_OK;
 }
 
 static HRESULT WINAPI PersistStorage_Load(IPersistStorage *iface, LPSTORAGE pStg)
@@ -92,8 +92,6 @@
     return E_NOTIMPL;
 }
 
-#define PERSTORAGE_THIS(ifce) DEFINE_THIS(WebBrowser, PersistStorage, iface)
-
 static const IPersistStorageVtbl PersistStorageVtbl =
 {
     PersistStorage_QueryInterface,
@@ -108,6 +106,87 @@
 };
 
 /**********************************************************************
+ * Implement the IPersistMemory interface
+ */
+
+#define PERMEMORY_THIS(ifce) DEFINE_THIS(WebBrowser, PersistMemory, iface)
+
+static HRESULT WINAPI PersistMemory_QueryInterface(IPersistMemory *iface,
+        REFIID riid, LPVOID *ppobj)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    return IWebBrowser_QueryInterface(WEBBROWSER(This), riid, ppobj);
+}
+
+static ULONG WINAPI PersistMemory_AddRef(IPersistMemory *iface)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    return IWebBrowser_AddRef(WEBBROWSER(This));
+}
+
+static ULONG WINAPI PersistMemory_Release(IPersistMemory *iface)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    return IWebBrowser_Release(WEBBROWSER(This));
+}
+
+static HRESULT WINAPI PersistMemory_GetClassID(IPersistMemory *iface, CLSID *pClassID)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)->(%p)\n", This, pClassID);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI PersistMemory_IsDirty(IPersistMemory *iface)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)\n", This);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI PersistMemory_InitNew(IPersistMemory *iface)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)\n", This);
+    return S_OK;
+}
+
+static HRESULT WINAPI PersistMemory_Load(IPersistMemory *iface, LPVOID pMem, ULONG cbSize)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)->(%p %x)\n", This, pMem, cbSize);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI PersistMemory_Save(IPersistMemory *iface, LPVOID pMem,
+        BOOL fClearDirty, ULONG cbSize)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)->(%p %x %x)\n", This, pMem, fClearDirty, cbSize);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI PersistMemory_GetSizeMax(IPersistMemory *iface, ULONG *pCbSize)
+{
+    WebBrowser *This = PERMEMORY_THIS(iface);
+    FIXME("(%p)->(%p)\n", This, pCbSize);
+    return E_NOTIMPL;
+}
+
+static const IPersistMemoryVtbl PersistMemoryVtbl =
+{
+    PersistMemory_QueryInterface,
+    PersistMemory_AddRef,
+    PersistMemory_Release,
+    PersistMemory_GetClassID,
+    PersistMemory_IsDirty,
+    PersistMemory_Load,
+    PersistMemory_Save,
+    PersistMemory_GetSizeMax,
+    PersistMemory_InitNew
+};
+
+/**********************************************************************
  * Implement the IPersistStreamInit interface
  */
 
@@ -148,7 +227,7 @@
 {
     WebBrowser *This = PERSTRINIT_THIS(iface);
     FIXME("(%p)->(%p)\n", This, pStg);
-    return E_NOTIMPL;
+    return S_OK;
 }
 
 static HRESULT WINAPI PersistStreamInit_Save(IPersistStreamInit *iface, LPSTREAM pStg,
@@ -171,7 +250,7 @@
 {
     WebBrowser *This = PERSTRINIT_THIS(iface);
     FIXME("(%p)\n", This);
-    return E_NOTIMPL;
+    return S_OK;
 }
 
 #undef PERSTRINIT_THIS
@@ -192,5 +271,6 @@
 void WebBrowser_Persist_Init(WebBrowser *This)
 {
     This->lpPersistStorageVtbl    = &PersistStorageVtbl;
+    This->lpPersistMemoryVtbl     = &PersistMemoryVtbl;
     This->lpPersistStreamInitVtbl = &PersistStreamInitVtbl;
 }
Index: dll/win32/shdocvw/frame.c
===================================================================
--- dll/win32/shdocvw/frame.c	(Revision 31635)
+++ dll/win32/shdocvw/frame.c	(Arbeitskopie)
@@ -13,7 +13,7 @@
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
 #include "wine/debug.h"
@@ -21,12 +21,12 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(shdocvw);
 
-#define INPLACEFRAME_THIS(iface) DEFINE_THIS(WebBrowser, OleInPlaceFrame, iface)
+#define INPLACEFRAME_THIS(iface) DEFINE_THIS(DocHost, OleInPlaceFrame, iface)
 
 static HRESULT WINAPI InPlaceFrame_QueryInterface(IOleInPlaceFrame *iface,
                                                   REFIID riid, void **ppv)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
 
     *ppv = NULL;
 
@@ -52,19 +52,19 @@
 
 static ULONG WINAPI InPlaceFrame_AddRef(IOleInPlaceFrame *iface)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
-    return IWebBrowser2_AddRef(WEBBROWSER(This));
+    DocHost *This = INPLACEFRAME_THIS(iface);
+    return IOleClientSite_AddRef(CLIENTSITE(This));
 }
 
 static ULONG WINAPI InPlaceFrame_Release(IOleInPlaceFrame *iface)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
-    return IWebBrowser2_Release(WEBBROWSER(This));
+    DocHost *This = INPLACEFRAME_THIS(iface);
+    return IOleClientSite_Release(CLIENTSITE(This));
 }
 
 static HRESULT WINAPI InPlaceFrame_GetWindow(IOleInPlaceFrame *iface, HWND *phwnd)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, phwnd);
     return E_NOTIMPL;
 }
@@ -72,14 +72,14 @@
 static HRESULT WINAPI InPlaceFrame_ContextSensitiveHelp(IOleInPlaceFrame *iface,
                                                         BOOL fEnterMode)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%x)\n", This, fEnterMode);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceFrame_GetBorder(IOleInPlaceFrame *iface, LPRECT lprectBorder)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, lprectBorder);
     return E_NOTIMPL;
 }
@@ -87,7 +87,7 @@
 static HRESULT WINAPI InPlaceFrame_RequestBorderSpace(IOleInPlaceFrame *iface,
                                                       LPCBORDERWIDTHS pborderwidths)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, pborderwidths);
     return E_NOTIMPL;
 }
@@ -95,7 +95,7 @@
 static HRESULT WINAPI InPlaceFrame_SetBorderSpace(IOleInPlaceFrame *iface,
                                                   LPCBORDERWIDTHS pborderwidths)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, pborderwidths);
     return E_NOTIMPL;
 }
@@ -103,7 +103,7 @@
 static HRESULT WINAPI InPlaceFrame_SetActiveObject(IOleInPlaceFrame *iface,
         IOleInPlaceActiveObject *pActiveObject, LPCOLESTR pszObjName)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p %s)\n", This, pActiveObject, debugstr_w(pszObjName));
     return E_NOTIMPL;
 }
@@ -111,7 +111,7 @@
 static HRESULT WINAPI InPlaceFrame_InsertMenus(IOleInPlaceFrame *iface, HMENU hmenuShared,
         LPOLEMENUGROUPWIDTHS lpMenuWidths)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p %p)\n", This, hmenuShared, lpMenuWidths);
     return E_NOTIMPL;
 }
@@ -119,14 +119,14 @@
 static HRESULT WINAPI InPlaceFrame_SetMenu(IOleInPlaceFrame *iface, HMENU hmenuShared,
         HOLEMENU holemenu, HWND hwndActiveObject)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p %p %p)\n", This, hmenuShared, holemenu, hwndActiveObject);
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceFrame_RemoveMenus(IOleInPlaceFrame *iface, HMENU hmenuShared)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, hmenuShared);
     return E_NOTIMPL;
 }
@@ -134,14 +134,14 @@
 static HRESULT WINAPI InPlaceFrame_SetStatusText(IOleInPlaceFrame *iface,
                                                  LPCOLESTR pszStatusText)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p)\n", This, debugstr_w(pszStatusText));
     return E_NOTIMPL;
 }
 
 static HRESULT WINAPI InPlaceFrame_EnableModeless(IOleInPlaceFrame *iface, BOOL fEnable)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%x)\n", This, fEnable);
     return E_NOTIMPL;
 }
@@ -149,7 +149,7 @@
 static HRESULT WINAPI InPlaceFrame_TranslateAccelerator(IOleInPlaceFrame *iface, LPMSG lpmsg,
                                                         WORD wID)
 {
-    WebBrowser *This = INPLACEFRAME_THIS(iface);
+    DocHost *This = INPLACEFRAME_THIS(iface);
     FIXME("(%p)->(%p %d)\n", This, lpmsg, wID);
     return E_NOTIMPL;
 }
@@ -174,7 +174,7 @@
     InPlaceFrame_TranslateAccelerator
 };
 
-void WebBrowser_Frame_Init(WebBrowser *This)
+void DocHost_Frame_Init(DocHost *This)
 {
     This->lpOleInPlaceFrameVtbl = &OleInPlaceFrameVtbl;
 }
Index: dll/win32/shdocvw/urlhist.c
===================================================================
--- dll/win32/shdocvw/urlhist.c	(Revision 0)
+++ dll/win32/shdocvw/urlhist.c	(Revision 0)
@@ -0,0 +1,131 @@
+/*
+ * Copyright 2006 Jacek Caban for CodeWeavers
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#include "wine/debug.h"
+#include "shdocvw.h"
+#include "urlhist.h"
+
+WINE_DEFAULT_DEBUG_CHANNEL(shdocvw);
+
+static HRESULT WINAPI UrlHistoryStg_QueryInterface(IUrlHistoryStg2 *iface, REFIID riid, void **ppv)
+{
+    *ppv = NULL;
+
+    if(IsEqualGUID(&IID_IUnknown, riid)) {
+        TRACE("(IID_IUnknown %p)\n", ppv);
+        *ppv = iface;
+    }else if(IsEqualGUID(&IID_IUrlHistoryStg, riid)) {
+        TRACE("(IID_IUrlHistoryStg %p)\n", ppv);
+        *ppv = iface;
+    }else if(IsEqualGUID(&IID_IUrlHistoryStg2, riid)) {
+        TRACE("(IID_IUrlHistoryStg2 %p)\n", ppv);
+        *ppv = iface;
+    }
+
+    if(*ppv) {
+        IUnknown_AddRef((IUnknown*)*ppv);
+        return S_OK;
+    }
+
+    WARN("(%s %p)\n", debugstr_guid(riid), ppv);
+    return E_NOINTERFACE;
+}
+
+static ULONG WINAPI UrlHistoryStg_AddRef(IUrlHistoryStg2 *iface)
+{
+    SHDOCVW_LockModule();
+    return 2;
+}
+
+static ULONG WINAPI UrlHistoryStg_Release(IUrlHistoryStg2 *iface)
+{
+    SHDOCVW_UnlockModule();
+    return 1;
+}
+
+static HRESULT WINAPI UrlHistoryStg_AddUrl(IUrlHistoryStg2 *iface, LPCOLESTR lpcsUrl,
+        LPCOLESTR pocsTitle, DWORD dwFlags)
+{
+    FIXME("(%s %s %08x)\n", debugstr_w(lpcsUrl), debugstr_w(pocsTitle), dwFlags);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_DeleteUrl(IUrlHistoryStg2 *iface, LPCOLESTR lpcsUrl,
+        DWORD dwFlags)
+{
+    FIXME("(%s %08x)\n", debugstr_w(lpcsUrl), dwFlags);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_QueryUrl(IUrlHistoryStg2 *iface, LPCOLESTR lpcsUrl,
+        DWORD dwFlags, LPSTATURL lpSTATURL)
+{
+    FIXME("(%s %08x %p)\n", debugstr_w(lpcsUrl), dwFlags, lpSTATURL);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_BindToObject(IUrlHistoryStg2 *iface, LPCOLESTR lpcsUrl,
+        REFIID riid, void **ppv)
+{
+    FIXME("(%s %s %p)\n", debugstr_w(lpcsUrl), debugstr_guid(riid), ppv);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_EnumUrls(IUrlHistoryStg2 *iface, IEnumSTATURL **ppEnum)
+{
+    FIXME("(%p)\n", ppEnum);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_AddUrlAndNotify(IUrlHistoryStg2 *iface, LPCOLESTR pocsUrl,
+        LPCOLESTR pocsTitle, DWORD dwFlags, BOOL fWriteHistory, IOleCommandTarget *poctNotify,
+        IUnknown *punkISFolder)
+{
+    FIXME("(%s %s %08x %x %p %p)\n", debugstr_w(pocsUrl), debugstr_w(pocsTitle),
+          dwFlags, fWriteHistory, poctNotify, punkISFolder);
+    return E_NOTIMPL;
+}
+
+static HRESULT WINAPI UrlHistoryStg_ClearHistory(IUrlHistoryStg2 *iface)
+{
+    FIXME("()\n");
+    return E_NOTIMPL;
+}
+
+static const IUrlHistoryStg2Vtbl UrlHistoryStg2Vtbl = {
+    UrlHistoryStg_QueryInterface,
+    UrlHistoryStg_AddRef,
+    UrlHistoryStg_Release,
+    UrlHistoryStg_AddUrl,
+    UrlHistoryStg_DeleteUrl,
+    UrlHistoryStg_QueryUrl,
+    UrlHistoryStg_BindToObject,
+    UrlHistoryStg_EnumUrls,
+    UrlHistoryStg_AddUrlAndNotify,
+    UrlHistoryStg_ClearHistory
+};
+
+static IUrlHistoryStg2 UrlHistoryStg2 = { &UrlHistoryStg2Vtbl };
+
+HRESULT CUrlHistory_Create(IUnknown *pOuter, REFIID riid, void **ppv)
+{
+    if(pOuter)
+        return CLASS_E_NOAGGREGATION;
+
+    return IUrlHistoryStg_QueryInterface(&UrlHistoryStg2, riid, ppv);
+}
